OSDN Git Service

gcc/ada:
[pf3gnuchains/gcc-fork.git] / maintainer-scripts / gcc_release
1 #! /bin/sh
2
3 ########################################################################
4 #
5 # File:   gcc_release
6 # Author: Jeffrey Law, Bernd Schmidt, Mark Mitchell
7 # Date:   2001-05-25
8 #
9 # Contents:
10 #   Script to create a GCC release.
11 #
12 # Copyright (c) 2001, 2002 Free Software Foundation.
13 #
14 # This file is part of GNU CC.
15 #
16 # GNU CC is free software; you can redistribute it and/or modify
17 # it under the terms of the GNU General Public License as published by
18 # the Free Software Foundation; either version 2, or (at your option)
19 # any later version.
20 #
21 # GNU CC is distributed in the hope that it will be useful,
22 # but WITHOUT ANY WARRANTY; without even the implied warranty of
23 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
24 # GNU General Public License for more details.
25 #
26 # You should have received a copy of the GNU General Public License
27 # along with GNU CC; see the file COPYING.  If not, write to
28 # the Free Software Foundation, 59 Temple Place - Suite 330,
29 # Boston, MA 02111-1307, USA.
30 #
31 ########################################################################
32
33 ########################################################################
34 # Notes
35 ########################################################################
36
37 # Here is an example usage of this script, to create a GCC 3.0.2
38 # prerelease:
39 #
40 #   gcc_release -r 3.0.2
41 #
42 # This script will automatically use the head of the release branch
43 # to generate the release.
44
45 ########################################################################
46 # Functions
47 ########################################################################
48
49 # Issue the error message given by $1 and exit with a non-zero
50 # exit code.
51
52 error() {
53     echo "gcc_release: error: $1"
54     exit 1
55 }
56
57 # Issue the informational message given by $1.
58
59 inform() {
60     echo "gcc_release: $1"
61 }
62
63 # Issue a usage message explaining how to use this script.
64
65 usage() {
66 cat <<EOF
67 gcc_release     [-d destination]
68                 [-u username]
69                 [-r release]
70                 [-t tag]
71                 [-p previous-tarball]
72                 [-s] [-f] [-l]
73 EOF
74     exit 1
75 }
76
77 # Change to the directory given by $1.
78
79 changedir() {
80   cd $1 || \
81     error "Could not change directory to $1"
82 }
83
84 # Each of the arguments is a directory name, relative to the top
85 # of the source tree.  Return another name for that directory, relative
86 # to the working directory.
87
88 adjust_dirs() {
89   for x in $@; do
90     echo `basename ${SOURCE_DIRECTORY}`/$x
91   done
92 }
93
94 # Build the source tree that will be the basis for the release
95 # in ${WORKING_DIRECTORY}/gcc-${RELEASE}.
96
97 build_sources() {
98   # If the WORKING_DIRECTORY already exists, do not risk destroying it.
99   if [ -r ${WORKING_DIRECTORY} ]; then
100     error "\`${WORKING_DIRECTORY}' already exists"
101   fi
102   # Create the WORKING_DIRECTORY.
103   mkdir "${WORKING_DIRECTORY}" \
104     || error "Could not create \`${WORKING_DIRECTORY}'"
105   changedir "${WORKING_DIRECTORY}"
106
107   # If this is a final release, make sure that the ChangeLogs
108   # and version strings are updated.
109   if [ ${FINAL} -ne 0 ]; then
110     inform "Updating ChangeLogs and version files"
111
112     ${CVS} co -d "`basename ${SOURCE_DIRECTORY}`" \
113            -r ${BRANCH} gcc || \
114            error "Could not check out release sources"
115     for x in `find ${SOURCE_DIRECTORY} -name ChangeLog`; do
116       cat - ${x} > ${x}.new <<EOF
117 ${LONG_DATE}  Release Manager
118
119         * GCC ${RELEASE} Released.
120
121 EOF
122       mv ${x}.new ${x} || \
123         error "Could not update ${x}"
124       (changedir `dirname ${x}` && \
125         ${CVS} ci -m 'Mark ChangeLog' `basename ${x}`) || \
126         error "Could not commit ${x}"
127     done
128
129     # Update `gcc/version.c'.  There are other version files
130     # as well, which should have release status updated.
131     for x in gcc/version.c; do 
132       y=`basename ${x}`
133       (changedir `dirname ${SOURCE_DIRECTORY}/${x}` && \
134           sed -e 's|= \".*\"|= \"'${RELEASE}'\"|g' < ${y} > ${y}.new && \
135           mv ${y}.new ${y} && \
136           ${CVS} ci -m 'Update version' ${y}) || \
137           error "Could not update ${x}"
138     done
139     for x in gcc/ada/gnatvsn.ads gcc/f/version.c libf2c/libF77/Version.c \
140              libf2c/libI77/Version.c libf2c/libU77/Version.c; do
141       y=`basename ${x}`
142       (changedir `dirname ${SOURCE_DIRECTORY}/${x}` && \
143           sed -e 's/experimental\|prerelease/release/g' < ${y} > ${y}.new && \
144           mv ${y}.new ${y} && \
145           ${CVS} ci -m 'Update version' ${y}) || \
146           error "Could not update ${x}"
147     done
148
149     # Make sure we tag the sources for a final release.
150     TAG="gcc_`echo ${RELEASE} | tr . _`_release"
151
152     rm -rf ${SOURCE_DIRECTORY}
153   fi
154
155   # Tag the sources.
156   if [ -n "${TAG}" ]; then
157     inform "Tagging release sources"
158     ${CVS} rtag -r ${BRANCH} -F ${TAG} gcc || \
159       error "Could not tag release sources"
160     BRANCH=$TAG
161   fi
162
163   # Export the current sources.
164   inform "Retrieving release sources"
165   ${CVS} \
166        export -d "`basename ${SOURCE_DIRECTORY}`" \
167        -r ${BRANCH} gcc || \
168     error "Could not retrieve release sources"
169
170   # Run gcc_update on them to set up the timestamps nicely.
171   changedir "gcc-${RELEASE}"
172   contrib/gcc_update --touch
173
174   # Obtain some documentation files from the wwwdocs module.
175   inform "Retrieving HTML documentation"
176   changedir "${WORKING_DIRECTORY}"
177   for x in bugs gnats faq; do
178     (${CVS} export -r HEAD wwwdocs/htdocs/${x}.html && \
179      cp ${WORKING_DIRECTORY}/wwwdocs/htdocs/${x}.html \
180         ${SOURCE_DIRECTORY}) || \
181       error "Could not retrieve ${x}.html"
182   done
183
184   inform "Generating plain-text documentation from HTML"
185   changedir "${SOURCE_DIRECTORY}"
186   for file in *.html; do
187     newfile=`echo $file | sed -e 's/.html//' | tr "[:lower:]" "[:upper:]"`
188     (${ENV} TERM=vt100 lynx -dump $file \
189        | sed -e "s#file://localhost`/bin/pwd`\(.*\)#http://gcc.gnu.org\1#g" \
190        > $newfile) || \
191      error "Could not regenerate documentation"
192   done
193
194   # For a prerelease or real release, we need to generate additional
195   # files not present in CVS.
196   changedir "${SOURCE_DIRECTORY}"
197   if [ $SNAPSHOT -ne 1 ]; then
198     # Generate the documentation.
199     inform "Building install docs"
200     SOURCEDIR=${SOURCE_DIRECTORY}/gcc/doc
201     DESTDIR=${SOURCE_DIRECTORY}/INSTALL
202     export SOURCEDIR
203     export DESTDIR
204     ${SOURCE_DIRECTORY}/gcc/doc/install.texi2html
205
206     # Regenerate the NEWS file.
207     contrib/gennews > gcc/NEWS || \
208       error "Could not regenerate NEWS files"
209
210     # Now, we must build the compiler in order to create any generated
211     # files that are supposed to go in the source directory.  This is
212     # also a good sanity check to make sure that the release builds
213     # on at least one platform.
214     inform "Building compiler"
215     OBJECT_DIRECTORY=../objdir
216     contrib/gcc_build -d ${SOURCE_DIRECTORY} -o ${OBJECT_DIRECTORY} build || \
217       error "Could not rebuild GCC"
218
219     # Regenerate the Fotran NEWS and BUGS files.
220     (cd ${OBJECT_DIRECTORY}/gcc && make f77.rebuilt) || \
221       error "Could not regenerate Fortran NEWS and BUGS files"
222   fi
223
224   # Move message catalogs to source directory.
225   mv ../objdir/gcc/po/*.gmo gcc/po/
226
227   # Create a `.brik' file to use for checking the validity of the
228   # release.
229   changedir "${SOURCE_DIRECTORY}"
230   BRIK_FILE=`mktemp /tmp/gcc_release.XXXXXXX`
231   ((find . -type f | sort > $BRIK_FILE) && \
232        brik -Gb -f ${BRIK_FILE} > .brik && \
233        rm ${BRIK_FILE}) || \
234      error "Could not compute brik checksum"
235 }
236
237 # Buid a single tarfile.  The first argument is the name of the name
238 # of the tarfile to build, without any suffixes.  They will be added
239 # automatically.  The rest of the arguments are the files or
240 # directories to include.
241
242 build_tarfile() {
243   # Get the name of the destination tar file.
244   TARFILE="$1.tar.gz"
245   shift
246
247   # Build the tar file itself.
248   (${TAR} cf - "$@" | ${GZIP} > ${TARFILE}) || \
249     error "Could not build tarfile"
250   FILE_LIST="${FILE_LIST} ${TARFILE}"
251 }
252
253 # Build the various tar files for the release.
254
255 build_tarfiles() {
256   inform "Building tarfiles"
257
258   changedir "${WORKING_DIRECTORY}"
259
260   # The GNU Coding Standards specify that all files should
261   # world readable.
262   chmod -R a+r ${SOURCE_DIRECTORY}
263   # And that all directories have mode 777.
264   find ${SOURCE_DIRECTORY} -type d -exec chmod 777 {} \;
265  
266   # Build one huge tarfile for the entire distribution.
267   build_tarfile gcc-${RELEASE} `basename ${SOURCE_DIRECTORY}`
268
269   # Now, build one for each of the languages.
270   build_tarfile gcc-ada-${RELEASE} ${ADA_DIRS}
271   build_tarfile gcc-g++-${RELEASE} ${CPLUSPLUS_DIRS}
272   build_tarfile gcc-g77-${RELEASE} ${FORTRAN_DIRS}
273   build_tarfile gcc-java-${RELEASE} ${JAVA_DIRS}
274   build_tarfile gcc-objc-${RELEASE} ${OBJECTIVEC_DIRS}
275   build_tarfile gcc-testsuite-${RELEASE} ${TESTSUITE_DIRS}
276    
277   # The core is everything else.
278   EXCLUDES=""
279   for x in ${ADA_DIRS} ${CPLUSPLUS_DIRS} ${FORTRAN_DIRS} \
280            ${JAVA_DIRS} ${OBJECTIVEC_DIRS} ${TESTSUITE_DIRS}; do
281     EXCLUDES="${EXCLUDES} --exclude $x"
282   done
283   build_tarfile gcc-core-${RELEASE} ${EXCLUDES} \
284     `basename ${SOURCE_DIRECTORY}`
285 }
286
287 # Build .bz2 files.
288 build_bzip2() {
289   for f in ${FILE_LIST}; do
290     bzfile=${f%.gz}.bz2
291     (zcat $f | ${BZIP2} > ${bzfile}) || error "Could not create ${bzfile}"
292   done
293 }
294
295 # Build diffs against an old release.
296 build_diffs() {
297   old_dir=${1%/*}
298   old_file=${1##*/}
299   old_vers=${old_file%.tar.gz}
300   old_vers=${old_vers#gcc-}
301   inform "Building diffs against version $old_vers"
302   for f in gcc gcc-ada gcc-g++ gcc-g77 gcc-java gcc-objc gcc-testsuite gcc-core; do
303     old_tar=${old_dir}/${f}-${old_vers}.tar.gz
304     new_tar=${WORKING_DIRECTORY}/${f}-${RELEASE}.tar.gz
305     if [ -e $old_tar ] && [ -e $new_tar ]; then
306       build_diff $old_tar gcc-${old_vers} $new_tar gcc-${RELEASE} \
307         ${f}-${old_vers}-${RELEASE}.diff.gz
308     fi
309   done
310 }
311
312 # Build an individual diff.
313 build_diff() {
314   changedir "${WORKING_DIRECTORY}"
315   tmpdir=gccdiff.$$
316   mkdir $tmpdir || error "Could not create directory $tmpdir"
317   changedir $tmpdir
318   tar xfz $1 || error "Could not unpack $1 for diffs"
319   tar xfz $3 || error "Could not unpack $3 for diffs"
320   ${DIFF} $2 $4 > ../${5%.gz}
321   if [ $? -eq 2 ]; then
322     error "Trouble making diffs from $1 to $3"
323   fi
324   ${GZIP} ../${5%.gz} || error "Could not gzip ../${5%.gz}"
325   changedir ..
326   rm -rf $tmpdir
327   FILE_LIST="${FILE_LIST} $5"
328 }
329
330 # Upload the files to the FTP server.
331
332 upload_files() {
333   inform "Uploading files"
334
335   changedir "${WORKING_DIRECTORY}"
336
337   # Make sure the directory exists on the server.
338   if [ $LOCAL -eq 0 ]; then
339     ${SSH} -l ${GCC_USERNAME} ${GCC_HOSTNAME} mkdir ${FTP_PATH}
340     UPLOAD_PATH="${GCC_USERNAME}@${GCC_HOSTNAME}:${FTP_PATH}"
341   else
342     mkdir -p "${FTP_PATH}" \
343       || error "Could not create \`${FTP_PATH}'"
344     UPLOAD_PATH=${FTP_PATH}
345   fi
346
347   for x in gcc*.gz gcc*.bz2; do
348     if [ -e ${x} ]; then
349       # Make sure the file will be readable on the server.
350       chmod a+r ${x}
351       # Copy it.
352       ${SCP} ${x} ${UPLOAD_PATH} || error "Could not upload ${x}"
353     fi
354   done
355 }
356
357 ########################################################################
358 # Initialization
359 ########################################################################
360
361 # Today's date.
362 DATE=`date "+%Y%m%d"`
363 LONG_DATE=`date "+%Y-%m-%d"`
364
365 # The CVS server containing the GCC repository.
366 CVS_SERVER="gcc.gnu.org"
367 # The path to the repository on that server.
368 CVS_REPOSITORY="/cvs/gcc"
369 # The CVS protocol to use.
370 CVS_PROTOCOL="ext"
371 # The username to use when connecting to the server.
372 CVS_USERNAME="${USER}"
373
374 # The machine to which files will be uploaded.
375 GCC_HOSTNAME="gcc.gnu.org"
376 # The name of the account on the machine to which files are uploaded.
377 GCC_USERNAME="gccadmin"
378 # The directory in which the files will be placed.
379 FTP_PATH="~ftp/pub/gcc"
380
381 # The major number for the release.  For release `3.0.2' this would be 
382 # `3'
383 RELEASE_MAJOR=""
384 # The minor number for the release.  For release `3.0.2' this would be
385 # `0'.
386 RELEASE_MINOR=""
387 # The revision number for the release.  For release `3.0.2' this would
388 # be `2'.
389 RELEASE_REVISION=""
390 # The complete name of the release.
391 RELEASE=""
392
393 # The name of the branch from which the release should be made.
394 BRANCH=""
395
396 # The tag to apply to the sources used for the release.
397 TAG=""
398
399 # The old tarballs from which to generate diffs.
400 OLD_TARS=""
401
402 # The directory that will be used to construct the release.  The
403 # release itself will be placed in a subdirectory of this diretory.
404 DESTINATION=${HOME}
405 # The subdirectory.
406 WORKING_DIRECTORY=""
407 # The directory that will contain the GCC sources.
408 SOURCE_DIRECTORY=""
409
410 # The directories that should be part of the various language-specific
411 # tar files.  These are all relative to the top of the source tree.
412 ADA_DIRS="gcc/ada"
413 CPLUSPLUS_DIRS="gcc/cp libstdc++-v3"
414 FORTRAN_DIRS="gcc/f libf2c"
415 JAVA_DIRS="gcc/java libjava libffi fastjar zlib boehm-gc"
416 OBJECTIVEC_DIRS="gcc/objc libobjc"
417 TESTSUITE_DIRS="gcc/testsuite"
418
419 # Non-zero if this is the final release, rather than a prerelease.
420 FINAL=0
421
422 # Non-zero if we are building a snapshot, and don't build gcc or
423 # include generated files.
424 SNAPSHOT=0
425
426 # Non-zero if we are running locally on gcc.gnu.org, and use local CVS
427 # and copy directly to the FTP directory.
428 LOCAL=0
429
430 # Major operation modes.
431 MODE_BZIP2=0
432 MODE_DIFFS=0
433 MODE_SOURCES=0
434 MODE_TARFILES=0
435 MODE_UPLOAD=0
436
437 # .gz files generated to create .bz2 files from.
438 FILE_LIST=""
439
440 # Programs we use.
441
442 BZIP2="${BZIP2:-bzip2}"
443 CVS="${CVS:-cvs -f -Q -z9}"
444 DIFF="${DIFF:-diff -Nrc3pad}"
445 ENV="${ENV:-env}"
446 GZIP="${GZIP:-gzip --best}"
447 SCP="${SCP:-scp -p}"
448 SSH="${SSH:-ssh}"
449 TAR="${TAR:-tar}"
450
451 ########################################################################
452 # Command Line Processing
453 ########################################################################
454
455 # Parse the options.
456 while getopts "d:fr:u:t:p:sl" ARG; do
457     case $ARG in
458     d)    DESTINATION="${OPTARG}";;
459     r)    RELEASE="${OPTARG}";;
460     t)    TAG="${OPTARG}";;
461     u)    CVS_USERNAME="${OPTARG}";;
462     f)    FINAL=1;;
463     s)    SNAPSHOT=1;;
464     l)    LOCAL=1
465           SCP=cp
466           FTP_PATH=~ftp/pub/gcc
467           PATH=~:/usr/local/bin:$PATH;;
468     p)    OLD_TARS="${OLD_TARS} ${OPTARG}"
469           if [ -d ${OPTARG} ]; then
470             error "-p argument must name a tarball"
471           fi;;
472     \?)   usage;;
473     esac
474 done
475 shift `expr ${OPTIND} - 1`
476
477 # Perform consistency checking.
478 if [ ${LOCAL} -eq 0 ] && [ -z ${CVS_USERNAME} ]; then
479   error "No username specified"
480 fi
481
482 if [ ! -d ${DESTINATION} ]; then
483   error "\`${DESTINATION}' is not a directory"
484 fi
485
486 if [ $SNAPSHOT -eq 0 ]; then
487   if [ -z ${RELEASE} ]; then
488     error "No release number specified"
489   fi
490
491   # Compute the major and minor release numbers.
492   RELEASE_MAJOR=`echo $RELEASE | awk --assign FS=. '{ print $1; }'`
493   RELEASE_MINOR=`echo $RELEASE | awk --assign FS=. '{ print $2; }'`
494   RELEASE_REVISION=`echo $RELEASE | awk --assign FS=. '{ print $3; }'`
495
496   if [ -z "${RELEASE_MAJOR}" ] || [ -z "${RELEASE_MINOR}" ]; then
497     error "Release number \`${RELEASE}' is invalid"
498   fi
499
500   # Compute the full name of the release.
501   if [ -z "${RELEASE_REVISION}" ]; then
502     RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}"
503   else
504     RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}.${RELEASE_REVISION}"
505   fi
506
507   # Compute the name of the branch, which is based solely on the major
508   # and minor release numbers.
509   BRANCH="gcc-${RELEASE_MAJOR}_${RELEASE_MINOR}-branch"
510
511   # If this is not a final release, set various parameters acordingly.
512   if [ ${FINAL} -ne 1 ]; then
513     RELEASE="${RELEASE}-${DATE}"
514     FTP_PATH="${FTP_PATH}/snapshots/"
515   else
516     FTP_PATH="${FTP_PATH}/releases/gcc-${RELEASE}/"
517   fi
518 else
519   RELEASE=$DATE
520   # For now snapshots come from the 3.1 branch.
521   BRANCH=gcc-3_1-branch
522   FTP_PATH="${FTP_PATH}/snapshots/${LONG_DATE}"
523   TAG=gcc_ss_${DATE}
524
525   # Building locally on gcc.gnu.org, we know what the last snapshot date
526   # was.
527   if [ $LOCAL -ne 0 ]; then
528     LAST_DATE=`cat ~/.snapshot_date`
529     LAST_LONG_DATE=`date --date=$LAST_DATE +%Y-%m-%d`
530     LAST_DIR=~ftp/pub/gcc/snapshots/${LAST_LONG_DATE}
531     OLD_TARS=${LAST_DIR}/gcc-${LAST_DATE}.tar.gz
532   fi
533 fi
534
535 # Compute the name of the WORKING_DIRECTORY and the SOURCE_DIRECTORY.
536 WORKING_DIRECTORY="${DESTINATION}/gcc-${RELEASE}"
537 SOURCE_DIRECTORY="${WORKING_DIRECTORY}/gcc-${RELEASE}"
538
539 # Recompute the names of all the language-specific directories,
540 # relative to the WORKING_DIRECTORY.
541 ADA_DIRS=`adjust_dirs ${ADA_DIRS}`
542 CPLUSPLUS_DIRS=`adjust_dirs ${CPLUSPLUS_DIRS}`
543 FORTRAN_DIRS=`adjust_dirs ${FORTRAN_DIRS}`
544 JAVA_DIRS=`adjust_dirs ${JAVA_DIRS}`
545 OBJECTIVEC_DIRS=`adjust_dirs ${OBJECTIVEC_DIRS}`
546 TESTSUITE_DIRS=`adjust_dirs ${TESTSUITE_DIRS}`
547
548 # Set up CVSROOT.
549 if [ $LOCAL -eq 0 ]; then
550     CVSROOT=":${CVS_PROTOCOL}:${CVS_USERNAME}@"
551     CVSROOT="${CVSROOT}${CVS_SERVER}:${CVS_REPOSITORY}"
552 else
553     CVSROOT="${CVS_REPOSITORY}"
554 fi
555 export CVSROOT
556
557 ########################################################################
558 # Main Program
559 ########################################################################
560
561 # Set the timezone to UTC
562 TZ="UTC0"
563 export TZ
564
565 # Handle the major modes.
566 while [ $# -ne 0 ]; do
567     case $1 in
568     bzip2)    MODE_BZIP2=1;;
569     diffs)    MODE_DIFFS=1;;
570     sources)  MODE_SOURCES=1;;
571     tarfiles) MODE_TARFILES=1;;
572     upload)   MODE_UPLOAD=1;;
573     all)      MODE_SOURCES=1; MODE_TARFILES=1; MODE_DIFFS=1; MODE_BZIP2=1; MODE_UPLOAD=1;;
574     *)        error "Unknown mode $1";;
575     esac
576     shift
577 done
578
579 # Build the source directory.
580
581 if [ $MODE_SOURCES -ne 0 ]; then
582   build_sources
583 fi
584
585 # Build the tar files.
586
587 if [ $MODE_TARFILES -ne 0 ]; then
588   build_tarfiles
589 fi
590
591 # Build diffs
592
593 if [ $MODE_DIFFS -ne 0 ]; then
594   # Possibly build diffs.
595   if [ -n "$OLD_TARS" ]; then
596     for old_tar in $OLD_TARS; do
597       build_diffs $old_tar
598     done
599   fi
600 fi
601
602 # Build bzip2 files
603 if [ $MODE_BZIP2 -ne 0 ]; then
604   build_bzip2
605 fi
606
607 # Upload them to the FTP server.
608
609 if [ $MODE_UPLOAD -ne 0 ]; then
610   upload_files
611
612   # For snapshots, make some further updates.
613   if [ $SNAPSHOT -ne 0 ] && [ $LOCAL -ne 0 ]; then
614     # Update links on the FTP server.
615     TEXT_DATE=`date --date=$DATE +%B\ %d,\ %Y`
616     cd ~ftp/pub/gcc/snapshots
617     sed -e "s%@DATE@%$DATE%g" -e "s%@LAST_DATE@%$LAST_DATE%g" \
618       -e "s%@LONG_DATE@%$LONG_DATE%g" \
619       -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-README > $$
620     mv $$ README
621     sed -e "s%@DATE@%$DATE%g" -e "s%@LAST_DATE@%$LAST_DATE%g" \
622       -e "s%@LONG_DATE@%$LONG_DATE%g" \
623       -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-index.html > $$
624     mv $$ index.html
625
626     touch LATEST-IS-$LONG_DATE
627     rm -f LATEST-IS-$LAST_LONG_DATE
628
629     # Update snapshot date file.
630     changedir ~
631     echo $DATE >.snapshot_date
632
633     # Update gcc_latest_snapshot tag.
634     ${CVS} rtag -d gcc_latest_snapshot gcc
635     ${CVS} rtag -rgcc_ss_${DATE} gcc_latest_snapshot gcc
636
637     # Announce the snapshot.
638     export QMAILHOST=gcc.gnu.org
639     mail -s "gcc-ss-$DATE is now available" gcc@gcc.gnu.org < ~ftp/pub/gcc/snapshots/README
640
641     # Remove working directory
642     rm -rf ${WORKING_DIRECTORY}
643   fi
644 fi